clear all;

N = 8;
fprintf(1,'Loading images as matrices...');
Img = {};
for i = 1:N
	x = load(['face' num2str(i) '.mat']);
	Img{i} = double(x.X);
end
fprintf(1,'done.\n');
[r,c] = size(Img{1});

% Put into vector form
fprintf(1,'Converting images into vector form ...');
X = zeros(r*c,N);
for i = 1:8
	X(:,i) = reshape(Img{i},c*r,1);
end
fprintf(1,'done.\n');

Min_X = min(min(X));
Max_X = max(max(X));
Clim = [Min_X, Max_X];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot the images
%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure(1);
colormap(gray);

fprintf(1,'Plotting 8 images...\n');
for i = 1:N
	subplot(3,3,i);
	%imagesc(eval(['I' num2str(i)]),Clim);
	imagesc(Img{i},Clim);
	axis('off')
	title(['face ' num2str(i)]);
end

% Corrupt Image 1
fprintf(1,'Corrupting image 1...');
Row_Start = 25;
Row_Stop = 30;
X1_Corrupt = Img{1};
X1_Corrupt(Row_Start:Row_Stop,:) = zeros(Row_Stop-Row_Start+1,c);

fprintf(1,'plotting it.\n');
subplot(3,3,9);
imagesc(X1_Corrupt,Clim);
axis('off')
title('face 1 - corrupt');
