%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Create new corrupted image
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fprintf(1,'Creating new corrupted image...\n');
X1_Corrupt = 200*ones(r,c);

Row_Start = 10; Row_Stop = 20;
X1_Corrupt(Row_Start:Row_Stop,:) = zeros(Row_Stop-Row_Start+1,c);

Row_Start = 40; Row_Stop = 50;
X1_Corrupt(Row_Start:Row_Stop,:) = zeros(Row_Stop-Row_Start+1,c);

Col_Start = 10; Col_Stop = 20;
X1_Corrupt(:,Col_Start:Col_Stop) = zeros(r,Col_Stop-Col_Start+1);

Col_Start = 40; Col_Stop = 50;
X1_Corrupt(:,Col_Start:Col_Stop) = zeros(r,Col_Stop-Col_Start+1);

figure(3);
colormap(gray);

subplot(2,2,1);
imagesc(X1_Corrupt,Clim);
axis('off')
title('New input');

% restore using GI
fprintf(1,'Restoring image with GI...\n');
X1_v = reshape(X1_Corrupt,c*r,1);  % to vector
X1_Res_v = W_GI*X1_v;
X1_Res_GI = reshape(X1_Res_v,r,c); % to matrix

subplot(2,2,2);
imagesc(X1_Res_GI,Clim);
axis('off')
title('Restoration - GI');

% restore using CMM
fprintf(1,'Restoring image with CMM...\n');
X1_Res_v = W_CMM*(X1_v - X_mean);
X1_Res_CMM = reshape(X1_Res_v,r,c); % to matrix

subplot(2,2,3);
imagesc(X1_Res_CMM,Clim);
axis('off')
title('Restoration - CMM');

% Novelty detection with GI
fprintf(1,'Novelty detection with GI...\n');
W = eye(r*c) - W_GI;
X1_Res_v = W*X1_v;
X1_ND_GI = reshape(X1_Res_v,r,c); % to matrix

subplot(2,2,4);
imagesc(X1_ND_GI,Clim);
axis('off')
title('Novelty detection of GI');
