% Compute GI
fprintf(1,'Computing GI weight matrix...\n');
Pinv_X = (inv(X'*X)) * X';
W_GI = X*Pinv_X;

% restore image using GI
fprintf(1,'Restoring image 1 with GI...\n');
X1_v = reshape(X1_Corrupt,c*r,1);  % to vector
X1_Res_v = W_GI*X1_v;
X1_Res_GI = reshape(X1_Res_v,r,c); % to matrix

figure(2);
colormap(gray);

subplot(2,2,1);
imagesc(X1_Res_GI, Clim);
axis('off')
title('GI');

% Compute CMM
fprintf(1,'Computing CMM weight matrix...\n');
X_mean = (mean(X'))';
Xm = X - repmat(X_mean,1,size(X,2));
W_CMM = (Xm*Xm')/N;

fprintf(1,'Restoring image 1 with CMM...\n');
X1_Res_v = W_CMM*(X1_v - X_mean) + X_mean;
%X1_Res_v = W_CMM*(X1_v - X_mean);
X1_Res_CMM = reshape(X1_Res_v,r,c);

subplot(2,2,2);
imagesc(X1_Res_CMM,Clim);
axis('off')
title('CMM');

fprintf(1,'Computing novelty detector of GI...\n');
% Novelty detection
%X1_Res_v = W_GI*X1_v;
X1_Res_v = (eye(r*c) - W_GI)*X1_v;
X1_ND_GI = reshape(X1_Res_v,r,c);

subplot(2,2,3);
imagesc(-X1_ND_GI);
axis('off')
title('Novelty detection of GI');
